regina::NSnapPeaCensusTri Class Reference
Standard Triangulations and Subcomplexes

Represents a 3-manifold triangulation from the SnapPea cusped census. More...

`#include <subcomplex/nsnappeacensustri.h>`

Inheritance diagram for regina::NSnapPeaCensusTri:

## Public Member Functions

NSnapPeaCensusTri * | clone () const
| Returns a newly created clone of this structure. More...
char | getSection () const
| Returns the section of the SnapPea census to which this triangulation belongs. More...
unsigned long | getIndex () const
| Returns the index of this triangulation within its particular section of the SnapPea census. More...
bool | operator== (const NSnapPeaCensusTri &compare) const
| Determines whether this and the given structure represent the same triangulation from the SnapPea census. More...
NManifold * | getManifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
NAbelianGroup * | getHomologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
Public Member Functions inherited from regina::NStandardTriangulation
virtual | ~NStandardTriangulation ()
| A destructor that does nothing. More...
std::string | getName () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | getTeXName () const
| Returns the name of this specific triangulation in TeX format. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NSnapPeaCensusTri * | isSmallSnapPeaCensusTri (const NComponent *comp)
| Determines if the given triangulation component is one of the smallest SnapPea census triangulations. More...
Static Public Member Functions inherited from regina::NStandardTriangulation
static NStandardTriangulation * | isStandardTriangulation (NComponent *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static NStandardTriangulation * | isStandardTriangulation (NTriangulation *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Static Public Attributes

static const char | SEC_5
| Represents the collection of triangulations formed from five or fewer tetrahedra (both orientable and non-orientable). More...
static const char | SEC_6_OR
| Represents the collection of orientable triangulations formed from six tetrahedra. More...
static const char | SEC_6_NOR
| Represents the collection of non-orientable triangulations formed from six tetrahedra. More...
static const char | SEC_7_OR
| Represents the collection of orientable triangulations formed from seven tetrahedra. More...
static const char | SEC_7_NOR
| Represents the collection of non-orientable triangulations formed from seven tetrahedra. More...

## Friends

class | NSnapPeaCensusManifold

## Additional Inherited Members

Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Detailed Description

Represents a 3-manifold triangulation from the SnapPea cusped census.

The SnapPea cusped census is the census of cusped hyperbolic 3-manifolds formed from up to seven tetrahedra. This census was tabulated by Callahan, Hildebrand and Weeks, and is shipped with SnapPea 3.0d3 (and also with Regina).

The census is split into five different sections according to number of tetrahedra and orientability. Each of these sections corresponds to one of the section constants defined in this class.

For further details regarding the SnapPea census, see "A census of cusped hyperbolic 3-manifolds", Patrick J. Callahan, Martin V. Hildebrand and Jeffrey R. Weeks, Math. Comp. 68 (1999), no. 225, pp. 321–332.

Note that this class is closely tied to NSnapPeaCensusManifold. In particular, the section constants defined in NSnapPeaCensusManifold and NSnapPeaCensusTri are identical, and so may be freely mixed. Furthermore, the section and index parameters of an NSnapPeaCensusTri are identical to those of its corresponding NSnapPeaCensusManifold.

All of the optional NStandardTriangulation routines are implemented for this class.

Test:
  Included in the test suite.

## Member Function Documentation

NSnapPeaCensusTri * regina::NSnapPeaCensusTri::clone | ( |  | ) | const

inline

Returns a newly created clone of this structure.

Returns
  a newly created clone.

NAbelianGroup* regina::NSnapPeaCensusTri::getHomologyH1 | ( |  | ) | const

virtual

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling NTriangulation::getHomologyH1() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this NStandardTriangulation describes an entire NTriangulation (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling NTriangulation::getHomologyH1() upon the associated real triangulation.

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::NStandardTriangulation.

unsigned long regina::NSnapPeaCensusTri::getIndex | ( |  | ) | const

inline

Returns the index of this triangulation within its particular section of the SnapPea census.

Note that indices for each section begin counting at zero.

Returns
  the index of this triangulation within its section.

NManifold* regina::NSnapPeaCensusTri::getManifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::NStandardTriangulation.

char regina::NSnapPeaCensusTri::getSection | ( |  | ) | const

inline

Returns the section of the SnapPea census to which this triangulation belongs.

This will be one of the section constants defined in this class.

Returns
  the section of the SnapPea census.

static NSnapPeaCensusTri* regina::NSnapPeaCensusTri::isSmallSnapPeaCensusTri | ( | const NComponent * | comp | ) |

static

Determines if the given triangulation component is one of the smallest SnapPea census triangulations.

This routine is able to recognise a small selection of triangulations from the beginning of the SnapPea census, by way of hard-coding their structures and properties. Most triangulations from the census however will not be recognised by this routine.

Parameters

  comp | the triangulation component to examine.

Returns
  a newly created structure representing the small SnapPea census triangulation, or `null` if the given component is not one of the few SnapPea census triangulations recognised by this routine.

bool regina::NSnapPeaCensusTri::operator== | ( | const NSnapPeaCensusTri & | compare | ) | const

inline

Determines whether this and the given structure represent the same triangulation from the SnapPea census.

Parameters

  compare | the structure with which this will be compared.

Returns
  `true` if and only if this and the given structure represent the same SnapPea census triangulation.

std::ostream& regina::NSnapPeaCensusTri::writeName | ( | std::ostream & | out | ) | const

virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

std::ostream& regina::NSnapPeaCensusTri::writeTeXName | ( | std::ostream & | out | ) | const

virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

## Member Data Documentation

const char regina::NSnapPeaCensusTri::SEC_5

static

Represents the collection of triangulations formed from five or fewer tetrahedra (both orientable and non-orientable).

There are 415 triangulations in this section.

const char regina::NSnapPeaCensusTri::SEC_6_NOR

static

Represents the collection of non-orientable triangulations formed from six tetrahedra.

There are 259 triangulations in this section.

const char regina::NSnapPeaCensusTri::SEC_6_OR

static

Represents the collection of orientable triangulations formed from six tetrahedra.

There are 962 triangulations in this section.

const char regina::NSnapPeaCensusTri::SEC_7_NOR

static

Represents the collection of non-orientable triangulations formed from seven tetrahedra.

There are 887 triangulations in this section.

const char regina::NSnapPeaCensusTri::SEC_7_OR

static

Represents the collection of orientable triangulations formed from seven tetrahedra.

There are 3552 triangulations in this section.

The documentation for this class was generated from the following file:

- subcomplex/nsnappeacensustri.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).